<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdministrativeZone1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfAdministrativeZone1 extends AbstractStructArrayBase
{
    /**
     * The AdministrativeZone1
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdministrativeZone1[]
     */
    public $AdministrativeZone1;
    /**
     * Constructor method for ArrayOfAdministrativeZone1
     * @uses ArrayOfAdministrativeZone1::setAdministrativeZone1()
     * @param \StructType\AdministrativeZone1[] $administrativeZone1
     */
    public function __construct(array $administrativeZone1 = array())
    {
        $this
            ->setAdministrativeZone1($administrativeZone1);
    }
    /**
     * Get AdministrativeZone1 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdministrativeZone1[]|null
     */
    public function getAdministrativeZone1()
    {
        return isset($this->AdministrativeZone1) ? $this->AdministrativeZone1 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdministrativeZone1 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdministrativeZone1 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdministrativeZone1ForArrayConstraintsFromSetAdministrativeZone1(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdministrativeZone1AdministrativeZone1Item) {
            // validation for constraint: itemType
            if (!$arrayOfAdministrativeZone1AdministrativeZone1Item instanceof \StructType\AdministrativeZone1) {
                $invalidValues[] = is_object($arrayOfAdministrativeZone1AdministrativeZone1Item) ? get_class($arrayOfAdministrativeZone1AdministrativeZone1Item) : sprintf('%s(%s)', gettype($arrayOfAdministrativeZone1AdministrativeZone1Item), var_export($arrayOfAdministrativeZone1AdministrativeZone1Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdministrativeZone1 property can only contain items of type \StructType\AdministrativeZone1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdministrativeZone1 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdministrativeZone1[] $administrativeZone1
     * @return \ArrayType\ArrayOfAdministrativeZone1
     */
    public function setAdministrativeZone1(array $administrativeZone1 = array())
    {
        // validation for constraint: array
        if ('' !== ($administrativeZone1ArrayErrorMessage = self::validateAdministrativeZone1ForArrayConstraintsFromSetAdministrativeZone1($administrativeZone1))) {
            throw new \InvalidArgumentException($administrativeZone1ArrayErrorMessage, __LINE__);
        }
        if (is_null($administrativeZone1) || (is_array($administrativeZone1) && empty($administrativeZone1))) {
            unset($this->AdministrativeZone1);
        } else {
            $this->AdministrativeZone1 = $administrativeZone1;
        }
        return $this;
    }
    /**
     * Add item to AdministrativeZone1 value
     * @throws \InvalidArgumentException
     * @param \StructType\AdministrativeZone1 $item
     * @return \ArrayType\ArrayOfAdministrativeZone1
     */
    public function addToAdministrativeZone1(\StructType\AdministrativeZone1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdministrativeZone1) {
            throw new \InvalidArgumentException(sprintf('The AdministrativeZone1 property can only contain items of type \StructType\AdministrativeZone1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdministrativeZone1[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdministrativeZone1|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdministrativeZone1|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdministrativeZone1|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdministrativeZone1|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdministrativeZone1|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdministrativeZone1
     */
    public function getAttributeName()
    {
        return 'AdministrativeZone1';
    }
}
