<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for StartingFromPriceFileFilter StructType
 * @subpackage Structs
 */
class StartingFromPriceFileFilter extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Id;
    /**
     * The CommercialName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CommercialName;
    /**
     * The CommercialDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CommercialDescription;
    /**
     * The CommercialDurationInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CommercialDurationInformation;
    /**
     * Constructor method for StartingFromPriceFileFilter
     * @uses StartingFromPriceFileFilter::setId()
     * @uses StartingFromPriceFileFilter::setCommercialName()
     * @uses StartingFromPriceFileFilter::setCommercialDescription()
     * @uses StartingFromPriceFileFilter::setCommercialDurationInformation()
     * @param int $id
     * @param string $commercialName
     * @param string $commercialDescription
     * @param string $commercialDurationInformation
     */
    public function __construct($id = null, $commercialName = null, $commercialDescription = null, $commercialDurationInformation = null)
    {
        $this
            ->setId($id)
            ->setCommercialName($commercialName)
            ->setCommercialDescription($commercialDescription)
            ->setCommercialDurationInformation($commercialDurationInformation);
    }
    /**
     * Get Id value
     * @return int
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param int $id
     * @return \StructType\StartingFromPriceFileFilter
     */
    public function setId($id = null)
    {
        // validation for constraint: int
        if (!is_null($id) && !(is_int($id) || ctype_digit($id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get CommercialName value
     * @return string|null
     */
    public function getCommercialName()
    {
        return $this->CommercialName;
    }
    /**
     * Set CommercialName value
     * @param string $commercialName
     * @return \StructType\StartingFromPriceFileFilter
     */
    public function setCommercialName($commercialName = null)
    {
        // validation for constraint: string
        if (!is_null($commercialName) && !is_string($commercialName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commercialName, true), gettype($commercialName)), __LINE__);
        }
        $this->CommercialName = $commercialName;
        return $this;
    }
    /**
     * Get CommercialDescription value
     * @return string|null
     */
    public function getCommercialDescription()
    {
        return $this->CommercialDescription;
    }
    /**
     * Set CommercialDescription value
     * @param string $commercialDescription
     * @return \StructType\StartingFromPriceFileFilter
     */
    public function setCommercialDescription($commercialDescription = null)
    {
        // validation for constraint: string
        if (!is_null($commercialDescription) && !is_string($commercialDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commercialDescription, true), gettype($commercialDescription)), __LINE__);
        }
        $this->CommercialDescription = $commercialDescription;
        return $this;
    }
    /**
     * Get CommercialDurationInformation value
     * @return string|null
     */
    public function getCommercialDurationInformation()
    {
        return $this->CommercialDurationInformation;
    }
    /**
     * Set CommercialDurationInformation value
     * @param string $commercialDurationInformation
     * @return \StructType\StartingFromPriceFileFilter
     */
    public function setCommercialDurationInformation($commercialDurationInformation = null)
    {
        // validation for constraint: string
        if (!is_null($commercialDurationInformation) && !is_string($commercialDurationInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commercialDurationInformation, true), gettype($commercialDurationInformation)), __LINE__);
        }
        $this->CommercialDurationInformation = $commercialDurationInformation;
        return $this;
    }
}
